//+------------------------------------------------------------------+
//|                                              Classic ZigZag .mq4 |
//|                                        Copyright  2008, Rone_IS |
//|                                            rone.sergey@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Rone_IS"
#property link      "rone.sergey@gmail.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 BlueViolet
#property indicator_width1 2
#property indicator_color2 Blue
#property indicator_width2 2
#property indicator_color3 Red
#property indicator_width3 2

extern double ReversePercent=0.2;
extern bool UseReverseInPoints = false;
extern int ReversePoints = 30;
extern bool ShowNoChangeTrack = false;

double zz[];
double trackUp[];
double trackDn[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----
   SetIndexBuffer(0,zz);
   SetIndexStyle(0,DRAW_SECTION);
   SetIndexLabel(0,"Classic ZigZag");
   SetIndexBuffer(1,trackUp);
   SetIndexStyle(1,DRAW_ARROW);      
   SetIndexArrow(1,159);
   SetIndexLabel(1,"Track Up");
   SetIndexBuffer(2,trackDn);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,159);
   SetIndexLabel(2,"Track Down");
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
int start()
  {
   double reverse, prev;
   bool up=true;
   int lastmax, lastmin;
   
   int counted_bars=IndicatorCounted();
   if (counted_bars>0) counted_bars--;
//----
   for (int i=Bars-1; i>=0; i--)
      {
      if (UseReverseInPoints)
         reverse = ReversePoints*Point;
      else
         reverse = NormalizeDouble(ReversePercent*Close[i]/100,Digits);
//--------------------------------
      if (up)
         {
         if (Close[i] > prev)
            {
            zz[i]=Close[i]; prev=Close[i]; zz[i+1]=EMPTY_VALUE; 
            trackUp[i]=Close[i]; trackDn[i]=EMPTY_VALUE;
            if (zz[i]>zz[lastmax])
               zz[lastmax]=EMPTY_VALUE;
            }
         else if (Close[i] < prev - reverse)
            {
            zz[i]=Close[i]; prev=Close[i]; up=false;
            lastmax=EMPTY_VALUE;
            trackDn[i]=Close[i]; trackUp[i]=EMPTY_VALUE;
            }
         else
            {
            zz[i]=EMPTY_VALUE;
            if (ShowNoChangeTrack)
               {
               trackUp[i]=prev; 
               trackDn[i]=EMPTY_VALUE;
               }
            if (zz[i+1] != EMPTY_VALUE)
               lastmax=i+1;
            }
         }
      else
         {
         if (Close[i] < prev)
            {
            zz[i]=Close[i]; prev=Close[i]; zz[i+1]=EMPTY_VALUE;
            trackDn[i]=Close[i]; trackUp[i]=EMPTY_VALUE;
            if (zz[i]<zz[lastmin])
               zz[lastmin]=EMPTY_VALUE;
            }
         else if (Close[i] > prev+reverse)
            {
            zz[i]=Close[i]; prev=Close[i]; up=true;
            lastmin=EMPTY_VALUE;
            trackUp[i]=Close[i]; trackDn[i]=EMPTY_VALUE;
            }
         else
            {
            zz[i]=EMPTY_VALUE;
            if (ShowNoChangeTrack)
               {
               trackDn[i]=prev; 
               trackUp[i]=EMPTY_VALUE;
               }
            if (zz[i+1] != EMPTY_VALUE)
               lastmin=i+1;
            }
         }         
      }

//----
   return(0);
  }
//+------------------------------------------------------------------+